<?php

class LocaleController extends RController {

    public function filters() {
        return array(
            'rights',
            'postOnly + delete', // we only allow deletion via POST request
        );
    }

    /**
     * Displays a particular model.
     * @param integer $id the ID of the model to be displayed
     */
    public function actionView($id) {
        $this->render('view', array(
            'model' => $this->loadModel($id),
        ));
    }

    /**
     * Creates a new model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     */
    public function actionCreate() {
        $model = new Locale;
        // Uncomment the following line if AJAX validation is needed
        $this->performAjaxValidation($model);
        if (isset($_POST['Locale'])) {
            $model->attributes = $_POST['Locale'];
            if ($model->save()) {
                Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully created.'));
                $this->redirect(array('admin'));
            }
        }
        $this->render('create', array(
            'model' => $model,
        ));
    }

    public function actionSetDefault() {
        $models = FlexLocale::model()->findAllByAttributes(array('active' => 1));
        if (isset($_POST['defaultLocale'])) {
            $model = FlexLocale::model()->findByPk($_POST['defaultLocale']);
            if ($model != NULL) {
                $defaultModels = FlexLocale::model()->findAllByAttributes(array('default' => 1, 'active' => 1));
                if ($defaultModels != NULL) {
                    foreach ($defaultModels as $m) {
                        $m->default = 0;
                        $m->save();
                    }
                }
                $model->default = 1;
                if ($model->save())
                    $this->redirect(array('admin'));
            }
        }
        $this->render('setDefault', array(
            'models' => $models,
        ));
    }

    public function actionQuickUpdate() {
        $es = new EditableSaver('Locale');
        $es->update();
    }

    /**
     * Deletes a particular model.
     * If deletion is successful, the browser will be redirected to the 'admin' page.
     * @param integer $id the ID of the model to be deleted
     */
    public function actionDelete($id) {
        $this->loadModel($id)->delete();
        // if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
        if (!isset($_GET['ajax'])) {
            Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully deleted.'));
            $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
        }
    }

    /**
     * Lists all models.
     */
    public function actionIndex() {
        $dataProvider = new CActiveDataProvider('Locale');
        $this->render('index', array(
            'dataProvider' => $dataProvider,
        ));
    }

    /**
     * Manages all models.
     */
    public function actionAdmin() {
        $model = new Locale('search');
        // $model = new FlexLocale('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['Locale']))
            $model->attributes = $_GET['Locale'];
        $this->render('admin', array(
            'model' => $model,
        ));
    }

    /**
     * Returns the data model based on the primary key given in the GET variable.
     * If the data model is not found, an HTTP exception will be raised.
     * @param integer $id the ID of the model to be loaded
     * @return Locale the loaded model
     * @throws CHttpException
     */
    public function loadModel($id) {
        $model = FlexLocale::model()->findByPk($id);
        if ($model === null)
            throw new CHttpException(404, 'The requested page does not exist.');
        return $model;
    }

    /**
     * Performs the AJAX validation.
     * @param Locale $model the model to be validated
     */
    protected function performAjaxValidation($model) {
        if (isset($_POST['ajax']) && $_POST['ajax'] === 'locale-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }

}
